Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography 1.21
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.bouncycastle.crypto.engines
Class SerpentEngine

    java.lang.Object
      |
      +--org.bouncycastle.crypto.engines.SerpentEngine

All Implemented Interfaces:
  BlockCipher

public class SerpentEngine
extends java.lang.Object
implements BlockCipher

Serpent is a 128-bit 32-round block cipher with variable key lengths, including 128, 192 and 256 bit keys conjectured to be at least as secure as three-key triple-DES.

Serpent was designed by Ross Anderson, Eli Biham and Lars Knudsen as a candidate algorithm for the NIST AES Quest.>

For full details see the The Serpent home page

Constructor Summary
`SerpentEngine()`

Method Summary
`java.lang.String` | `getAlgorithmName()` Return the name of the algorithm the cipher implements.
`int` | `getBlockSize()` Return the block size for this cipher (in bytes).
`void` | `init(boolean encrypting, CipherParameters params)` initialise a Serpent cipher.
`int` | `processBlock(byte[] in, int inOff, byte[] out, int outOff)` Process one block of input from the array in and write it to the out array.
`void` | `reset()` Reset the cipher.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SerpentEngine

    public SerpentEngine()

Method Detail

### init

    public void init(boolean encrypting,
                     CipherParameters params)

  initialise a Serpent cipher.

  Specified by:
    `init` in interface `BlockCipher`
  Parameters:
    `params` - the parameters required to set up the cipher.
    `encrypting` - if true the cipher is initialised for encryption, if false for decryption.
  Throws:
    `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

### getAlgorithmName

    public java.lang.String getAlgorithmName()

  Description copied from interface: `BlockCipher`
  Return the name of the algorithm the cipher implements.

  Specified by:
    `getAlgorithmName` in interface `BlockCipher`
  Returns:
    the name of the algorithm the cipher implements.

### getBlockSize

    public int getBlockSize()

  Description copied from interface: `BlockCipher`
  Return the block size for this cipher (in bytes).

  Specified by:
    `getBlockSize` in interface `BlockCipher`
  Returns:
    the block size for this cipher in bytes.

### processBlock

    public final int processBlock(byte[] in,
                                  int inOff,
                                  byte[] out,
                                  int outOff)

  Process one block of input from the array in and write it to the out array.

  Specified by:
    `processBlock` in interface `BlockCipher`
  Parameters:
    `in` - the array containing the input data.
    `inOff` - offset into the in array the data starts at.
    `out` - the array the output data will be copied into.
    `outOff` - the offset into the out array the output will start at.
  Returns:
    the number of bytes processed and produced.
  Throws:
    `DataLengthException` - if there isn't enough data in in, or space in out.
    `java.lang.IllegalStateException` - if the cipher isn't initialised.

### reset

    public void reset()

  Description copied from interface: `BlockCipher`
  Reset the cipher. After resetting the cipher is in the same state as it was after the last init (if there was one).

  Specified by:
    `reset` in interface `BlockCipher`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography 1.21
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD